#define WIN32_LEAN_AND_MEAN

#include "libteraview.h"

#include <stdlib.h>
#include <conio.h>

int count = 0;
#define help "Press\n\t'0'-'9' to change exposure\n\t'B' to record background\n\t'N' to record normalization\n\t'd' to select default nomalization\n\t'r' to select recorded normalization\n\t's' to save configuration\n\t'l' to load configuration\n\tESC to quit.\n"

int pt(double p){
	if (p * 100 >= count) {
		printf("%3d%% ", (int)(p * 100));
		count += 5;
	}
	if (count > 100)
		count =0;
	return 0;
}

int main(int argc, char* argv[])
{	
	TS_RES res = TS_OK;
	TS_DATA buf;
	char * s;
	int offset, s_size;
	int i;;

	char ch;

	
	res = tsInit();
	if (res) {
		printf("Device initialization failed, code %d",res);
		return res;
	}
	
	buf = (TS_DATA) malloc(dataLength*sizeof(TS_ELEMENT));

	s_size = sizeof(char) * 5 * dataLength + sizeY + 100;
	s = (char*)malloc(s_size);
	
	res = tsStart();
	res = tsSetDifference(1);

	i = 0;
	for (ch = 0; ch != 27; ) {
		if (tsRead(buf) != TS_OK){
			printf("Error reading data.\n");
			break;
		}

		offset = sprintf_s(s, s_size, "[exposure %02d]%3d:\n", tsGetExposure(), i++);
		for (int j = 0; j < sizeY; j++){
			for (int k = 0; k < sizeX; k++){
				offset += sprintf_s(s + offset, s_size - offset, "%4d ", buf[k*sizeY + j]);
			}
			offset += sprintf_s(s + offset, s_size - offset, "\n");
		}
		system("cls");
		printf("%s", s);
		printf("%s", help);

		if (_kbhit()){
			ch = _getch();
			switch (ch){
			case '0': tsSetExposure(0); break;
			case '1': tsSetExposure(1); break;
			case '2': tsSetExposure(2); break;
			case '3': tsSetExposure(3); break;
			case '4': tsSetExposure(4); break;
			case '5': tsSetExposure(5); break;
			case '6': tsSetExposure(6); break;
			case '7': tsSetExposure(7); break;
			case '8': tsSetExposure(8); break;
			case '9': tsSetExposure(9); break;
			case 'N': {system("cls"); 
				printf("\nRecording normalization.\nPercents done:"); 
				if (tsRecordNormalization(&pt) == TS_OK) {
					printf("\nSuccess!\n"); 
				}
				else{
					printf("\nFailed!\n");
				}
				getchar();
			}break;
			case 'B': {system("cls"); 
				printf("\nRecording normalization.\nPercents done:"); 
				if (tsRecordBackground(&pt) == TS_OK){
					printf("\nSuccess!\n");
				}
				else{
					printf("\nFailed!\n");
				}
			}break;
			case 'd': {system("cls"); tsSelectNorm(0); printf("Default normalization selected.\nPress any key to continue.\n"); getchar(); } break;
			case 'r': {system("cls"); tsSelectNorm(1); printf("Recorded normalization selected.\nPress any key to continue.\n"); getchar(); } break;
			case 's': {system("cls");
				if (tsSaveConfigAs("config.bin") == TS_OK)
				{
					printf("Configuration saved to the file config.bin.\nPress any key to continue.\n"); 
				}
				else{
					printf("Saving configuration to the file config.bin failed!.\nPress any key to continue.\n");
				}
				getchar();
			} break;
			case 'l': {system("cls");
				if (tsLoadConfigFrom("config.bin") == TS_OK)
				{
					printf("Configuration loaded from the file config.bin.\nPress any key to continue.\n");
				}
				else{
					printf("Loading configuration from the file config.bin failed!.\nPress any key to continue.\n");
				}
				getchar(); 
			} break;
			default: continue;
			}
			i = 0;

		}
	}




	
	res = tsStop();
	res = tsClose();
	free(buf);
	free(s);
	return res;
}

